unit fgSudokup;

// Calcule la (ou les) solutions d'une grille Sudoku
// Auteur : Franois GOETHALS

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ToolWin, ComCtrls, ExtCtrls, DateUtils;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Quitter1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Jeu1: TMenuItem;
    Affichesolution1: TMenuItem;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    Rinitialiser1: TMenuItem;
    Coception1: TMenuItem;
    Nouvellegrille1: TMenuItem;
    Modifiergrille1: TMenuItem;
    Jouer2: TMenuItem;
    Jouer3: TMenuItem;
    Importer1: TMenuItem;
    procedure Importer1Click(Sender: TObject);
    procedure Modifiergrille1Click(Sender: TObject);
    procedure Nouvellegrille1Click(Sender: TObject);
    procedure Rinitialiser1Click(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure Jouer1Click(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClick(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure FormPaint(Sender: TObject);
    procedure Affichesolution1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Quitter1Click(Sender: TObject);
    procedure dessine_grille(Sender: TObject);
    procedure affiche_case(Sender: TObject;ipCase,ipType: integer;spString: string);
    procedure deplace_case_courante(Sender: TObject;ipCase: integer;fpMemorise: boolean);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  sgFichierGrille: string;    // Nom du fichier contenant la grille
  igCaseCourante: integer;    // indice de la case pointe
  igX,igY: integer;           // coordonnes de la souris
  sgEdit: string;             // Edition case courante
  sgOldCase: string;          // Valeur avant dition de la case
  slgCase: TstringList;       // cases  0=vide;
                              //        1N=valeur initiale N;
                              //        2N=valeur trouve N;
                              //        3N,M= mmoris N ou M
  igHypothese: integer;       // Numro de la dernire hypothese
  slgSolution: TstringList;   // solution calcule ou charge
  slgCaseJouee: TstringList;  // cases joues = case/ancienne valeur/nouvelle valeur
  fgEditJeu: boolean;         // =True  => dfinition ou modification du jeu
  fgSolutionTrouvee: boolean; // =True  => solution est soit donne soit calcule
  fgGrilleChargee: boolean;   // =True  => une grille est charge
  fgAfficheSolution: boolean; // =True  => affiche une solution (slgSolution)
                              // =False => affiche le jeu (slgCase)

implementation

{$R *.dfm}

function indice(ipx,ipy: integer): integer;
{ Cette fonction donne l'indice dans la TstrList de la case qui est en
    ipx (colonne de 0  8 )
    ipy (ligne de 0  8 )              }
begin
  Result:=(ipy * 9) + ipx;
end;

procedure decode_case(slpCase: TstringList; ipCase: integer;
                      var ipType: integer; var spString: string);
begin
  spString:=slpCase[ipCase];
  ipType:=strToInt(copy(spString,1,1));
  if length(spString) = 1 then spString:=''
  else spString:=copy(spString,2,length(spString)-1);
end;

function solution_case(ipCase: integer; fpSolution: boolean): string;
{ fonction qui retour un string contenant les solutions possibles spares par , }
var
  i,i1,j,k,l,ldeb,kdeb: integer;
  sSolution,sCase: string;
  itSolution: array[1..9] of integer;
begin
  for i := 1 to 9 do itSolution[i]:=0;
  { la case est sur la ligne l (de 0  8) }
  l:=trunc(ipCase/9);
  { recherche sur les cases de la ligne }
  for j := 0 to 8 do begin
    if indice(j,l)<>ipCase then begin
      if (fpSolution = True) then sCase:=slgSolution[indice(j,l)]
      else sCase:=slgCase[indice(j,l)];
      if (copy(sCase,1,1) = '1') or
         (copy(sCase,1,1) = '2') then begin
        i1:=pos('/',sCase);
        if (i1 = 0) then i1:=length(sCase)+1;
        sSolution:=copy(sCase,2,i1-2);
        itSolution[strToInt(sSolution)]:=1;
      end;
    end;
  end;
  { recherche sur les cases de la colonne }
  { la case est sur la colonne k }
  k:=ipCase mod 9;
  for j := 0 to 8 do begin
    if (fpSolution = True) then sCase:=slgSolution[indice(k,j)]
    else sCase:=slgCase[indice(k,j)];
    if j<>l then begin
      if (copy(sCase,1,1) = '1') or
         (copy(sCase,1,1) = '2') then begin
        i1:=pos('/',sCase);
        if (i1 = 0) then i1:=length(sCase)+1;
        sSolution:=copy(sCase,2,i1-2);
        itSolution[strToInt(sSolution)]:=1;
      end;
    end;
  end;
  { recherche sur les cases du carr }
  { indice de la ligne de dbut du carr }
  ldeb:=l - (l mod 3);
  { indice de la colonne de dbut du carr }
  kdeb:=k - (k mod 3);
  for i := 0 to 2 do
    for j := 0 to 2 do begin
      if (fpSolution = True) then sCase:=slgSolution[indice(kdeb+j,ldeb+i)]
      else sCase:=slgCase[indice(kdeb+j,ldeb+i)];
      if indice(kdeb+j,ldeb+i)<>ipCase then
        if (copy(sCase,1,1) = '1') or
           (copy(sCase,1,1) = '2') then begin
          i1:=pos('/',sCase);
          if (i1 = 0) then i1:=length(sCase)+1;
          sSolution:=copy(sCase,2,i1-2);
          itSolution[strToInt(sSolution)]:=1;
        end;
    end;
  { i est-il une solution ? }
  sSolution:='';
  for i := 1 to 9 do
    if (itSolution[i] = 0) then
      sSolution:=sSolution+','+intToStr(i);
  if length(sSolution) > 0 then
    Result:=copy(sSolution,2,length(sSolution)-1)
  else
    Result:='';
end;

procedure Verifie_grille(var ipCaseErronee,ipCaseUniSol,ipCaseMultiSol: integer);
var
  i,j,iNbSol,iNbSolMin: integer;
  sSolution: string;
begin
  { recherche de case  1 ou n solutions }
  ipCaseErronee:=-1;
  ipCaseMultiSol:=-1;
  ipCaseUniSol:=-1;
  iNbSolMin:=10;
  for i := 0 to slgCase.Count - 1 do begin
    if (ipCaseErronee = -1) and
       ((slgCase[i] = '0') or (copy(slgCase[i],1,1) = '3')) then begin
      sSolution:=solution_case(i,False);
      if sSolution = '' then begin
        { case sans solution }
        ipCaseErronee:=i;
      end
      else if pos(',',sSolution) = 0  then begin
        { case avec solution unique }
        if ipCaseUniSol = -1 then ipCaseUniSol:=i;
      end
      else begin
        { case avec plusieurs solutions }
        iNbSol:=1;
        repeat
          j:=pos(',',sSolution);
          sSolution:=copy(sSolution,j+1,length(sSolution)-j);
          inc(iNbSol);
        until (j = 0);
        if iNbSol < iNbSolMin then begin
          ipCaseMultiSol:=i;
          iNbSolMin:=iNbSol;
        end;
      end;
    end;
  end;
end;

function fiSolution(sSolution: string; iOcc: integer) : integer;
var
  i,iPos,iRes: integer;
  sSol: string;
begin
  { recherche dans sSolution la solution d'occurence iOcc }
  sSol:=sSolution;
  sSol:=copy(sSol,2,length(sSol)-1);
  iRes:=0;
  for i := 1 to iOcc do begin
    iPos:=pos(',',sSol);
    if iPos > 0 then begin
      iRes:=strToInt(copy(sSol,1,ipos-1));
      sSol:=copy(sSol,iPos+1,length(sSol)-iPos);
    end
    else begin
      if sSol = '' then iRes:=-1
      else begin
        iRes:=strToInt(sSol);
        sSol:='';
      end;
    end;
  end;
  Result:=iRes;
end;

function calcule_solution(Sender: TObject) : integer;
var
  fout: textFile;
  slOrdreSolution,slHypCase,slHypOcc,slHypSol: TstringList;
  iNbHypMin,iCaseHypMin,iNbHyp,iPos: integer;
  i,iCaseMultiSol,j,i1,iSol,iNbSol: Integer;
  sSolution,sSol,sEnreg: string;
  fTrouve,fCaseErronee,fSolutionTrouvee,fSolutionSuivante: boolean;
  F: TSearchRec;
begin
  { efface tous les fichiers solutions prcedents }
  if (findFirst('.\\Solution*.txt',0,F) = 0) then
  repeat
    deleteFile(F.Name);
  until (FindNext(F) <> 0);
  iNbSol:=0;
  { cree le stringList de l'ordre des solutions }
  slOrdreSolution:=TstringList.Create;
  { cree les stringList des hypotheses de solutions Case, solutions, occurence}
  slHypCase:=TstringList.Create;
  slHypSol:=TstringList.Create;
  slHypOcc:=TstringList.Create;
  slgSolution.Clear;
  { copie les cases ayant des valeurs initiales }
  for i := 0 to slgCase.Count - 1 do begin
    if (copy(slgCase[i],1,1) = '1') or (copy(slgCase[i],1,1) = '2') then
      slgSolution.Add(slgCase[i])
    else
      slgSolution.Add('0');
  end;
  { recherche des solutions }
  fSolutionSuivante:=False;
  repeat
    repeat
      repeat
        iCaseMultiSol:=-1;
        { recherche de case  1 solution }
        fTrouve:=False;
        fCaseErronee:=False;
        for i := 0 to slgSolution.Count - 1 do begin
          if (fCaseErronee = False) and
             ((slgSolution[i] = '0') or (copy(slgSolution[i],1,1) = '3')) then begin
            sSolution:=solution_case(i,True);
            if sSolution = '' then begin
              { case sans solution => annuler l'hypothese en-cours }
              fCaseErronee:=True;
              fTrouve:=False;
            end
            else if pos(',',sSolution) = 0  then begin
              { case avec solution unique }
              slgSolution[i]:='2'+sSolution;
              slOrdreSolution.add(intToStr(i));
              fTrouve:=True;
            end
            else begin
              { case avec plusieurs solutions }
              slgSolution[i]:='3'+sSolution;
              if iCaseMultiSol = -1 then iCaseMultiSol:=i;
            end;
          end;
        end;
      until (fTrouve = False);
      { il n'y a plus de case  1 solution }
      if (iCaseMultiSol > -1) and (fCaseErronee = False) then begin
        { il reste des cases avec des solutions multiples
          et pas de case sans solution possible
          => recherche d'une nouvelle hypothese }
        { recherche d'une case avec le moins de solutions possibles }
        iCaseHypMin:=-1;
        iNbHypMin:=10;
        for i := 0 to slgSolution.Count - 1 do begin
          if (copy(slgSolution[i],1,1) = '3') then begin
            { case  solution miltiple }
            { calcule le nombre de solutions possible => iNbHyp }
            iNbHyp:=1;
            sSol:=slgSolution[i];
            repeat
              iPos:=pos(',',sSol);
              if iPos > 0 then begin
                inc(iNbHyp);
                sSol:=copy(sSol,iPos+1,length(sSol)-iPos);
              end;
            until iPos = 0;
            if iNbHyp < iNbHypMin then begin
              { cette case a moins de solution possible que les autres cases }
              iNbHypMin:=iNbHyp;
              iCaseHypMin:=i;
            end;
          end;
        end;
        if iCaseHypMin > -1 then begin
          { il y a une case avec des solutions possibles => nouvelle hypothese }
          slHypCase.Add(intToStr(iCaseHypMin));
          slHypOcc.add('0');
          slHypSol.add(slgSolution[iCaseHypMin]);
        end;
      end;
      if (iCaseMultiSol > -1) or (fCaseErronee = True) or
         (fSolutionSuivante = True) then begin
        fSolutionSuivante:=False;
        if slHypCase.Count > 0 then begin
          { il y a un ensemble d'hypotheses  exploiter }
          fTrouve:=False;
          repeat
            { j'efface les solutions trouves depuis la derniere hypothese }
            i:=slOrdreSolution.IndexOf(slHypCase[slHypCase.count - 1]);
            if i > -1 then begin
              i:=slOrdreSolution.Count - i - 1;
              for i1 := 0 to i do begin
                slgSolution[strToInt(slOrdreSolution[slOrdreSolution.Count - 1])]:='0';
                slOrdreSolution.Delete(slOrdreSolution.Count - 1);
              end;
            end;
            { j'exploite l'occurence suivante de la dernire hypothese }
            slHypOcc[slHypOcc.count - 1]:=
              intToStr(strToInt(slHypOcc[slHypOcc.count - 1]) + 1);
            iSol:=fiSolution(slHypSol[slHypSol.count - 1],
                             strToInt(slHypOcc[slHypOcc.count - 1]));
            if iSol > 0 then begin
              { il y a une occurence restante  exploiter }
              slgSolution[strToInt(slHypCase[slHypCase.count - 1])]:= '2' +
                intToStr(iSol);
              slOrdreSolution.add(intToStr(strToInt(slHypCase[slHypCase.count - 1])));
              fTrouve:=True;
            end
            else begin
              { il n'y a plus d'occurence  exploiter dans l'hypothese
                => ensembles d'hypotheses prcdentes }
              slHypCase.Delete(slHypCase.Count - 1);
              slHypSol.Delete(slHypSol.Count - 1);
              slHypOcc.Delete(slHypOcc.Count - 1);
            end;
          until (fTrouve = True) or (slHypCase.Count = 0);
        end
        else iCaseMultiSol:=-1;
      end;
    until (iCaseMultiSol = -1) or (slHypCase.Count = 0);
    { une solution a-t-elle t trouve }
    fSolutionTrouvee:=True;
    for i := 0 to slgSolution.Count - 1 do
      if (copy(slgSolution[i],1,1) <> '1') and
         (copy(slgSolution[i],1,1) <> '2') then fSolutionTrouvee:=False;
    if fSolutionTrouvee = True then begin
      inc(iNbSol);
      { sauvegarde la grille }
      AssignFile(fout,'Solution'+copy('00000'+intToStr(iNbSol),length(intToStr(iNbSol)),6)+'.txt');
      {$I-}
      rewrite(fout);
      {$I+}
      { Enregistre la taille }
      writeln(fout,'Sudoku:');
      writeln(fout,'Solution'+copy(intToStr(iNbSol)+'     ',1,6));
      { Enregistre les cases }
      sEnreg:=slgCase[0];
      for i := 0 to 8 do begin
        sEnreg:='';
        for j := 0 to 8 do begin
          sEnreg:=sEnreg+copy(slgSolution[indice(j,i)]+'         ',1,9);
        end;
        writeln(fout,sEnreg);
      end;
      closeFile(fout);
      fSolutionSuivante:=True;
      fgSolutionTrouvee:=True;
    end;
  until (slHypCase.Count = 0);
  slOrdreSolution.Free;
  slHypCase.Free;
  slHypSol.Free;
  slHypOcc.Free;
  Result:=iNbSol;
end;

procedure decode_casejouee(ipIndice: integer;var ipCase: integer;var spOldCase: string);
var
  sCase: string;
  i: integer;
begin
  ipCase:=-1;
  if (slgCaseJouee.Count > 0) and (slgCaseJouee.Count > ipIndice) then begin
    sCase:=slgCaseJouee[ipIndice];
    i:=pos('/',sCase);
    if (i > 0) then begin
      ipCase:=strToInt(copy(sCase,1,i-1));
      spOldCase:=copy(sCase,i+1,length(sCase)-i);
    end
    else ipCase:=-1;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  i,j,k: integer;
  sW: string;
begin
  with Form1 do begin
    if fgGrilleChargee = True then begin
      dessine_grille(sender);
      for i := 0 to 8 do
        for j := 0 to 8 do begin
          if (fgAfficheSolution = True) then
            decode_case(slgSolution,indice(j,i),k,sW)
          else
            decode_case(slgCase,indice(j,i),k,sW);
          affiche_case(Sender,indice(j,i),k,sW);
        end;
      { panneau 0 : nom du fichier grille }
      StatusBar1.Panels[0].Text:=copy(sgFichierGrille+
        '                                                            ',1,60);
      { panneau 2 : nombre de coups jous }
      StatusBar1.Panels[2].Text:=copy(intToStr(slgCaseJouee.count)+'          ',1,10);
      { panneau 1 : mode conception ou jeu }
      if (fgEditJeu = True) then begin
        StatusBar1.Panels[1].Text:=' Conception ';
        StatusBar1.Panels[3].Text:='                     ';
      end
      else begin
        StatusBar1.Panels[1].Text:='   Jeu     ';
      end;
    end;
  end;
end;

procedure TForm1.dessine_grille(Sender: TObject);
var
  iNbLig,iNbCol,iCorr: integer;
begin
  if (fgGrilleChargee = True) then begin
    Canvas.Brush.Color:=clBtnFace;
    Canvas.FillRect(Rect(0,0,Form1.ClientWidth,Form1.ClientHeight));
    { dessine les lignes }
    for iNbLig := 0 to 9 do begin
      if iNbLig mod 3 = 0 then begin
        Canvas.Pen.Width:=3;
        iCorr:=0;
      end
      else begin
        Canvas.Pen.Width:=1;
        iCorr:=0;
      end;
      Canvas.MoveTo(10-iCorr,30+(60*iNbLig));
      Canvas.LineTo(10+(60*9)+iCorr,30+(60*iNbLig));
    end;
    { dessine les colonnes }
    for iNbCol := 0 to 9 do begin
      if iNbCol mod 3 = 0 then begin
        Canvas.Pen.Width:=3;
        iCorr:=0;
      end
      else begin
        Canvas.Pen.Width:=1;
        iCorr:=0;
      end;
      Canvas.MoveTo(10+(60*iNbCol),30-iCorr);
      Canvas.LineTo(10+(60*iNbCol),30+540+iCorr);
    end;
  end;
end;

procedure verifie_nombre(spResultat: string;ipMin,ipMax: integer;
                         var ipResultat: integer;var fpError: boolean);
{ procdure qui vrife qu'il peut traduire spResultat en ipResultat
  compris entre iPmin et ipMax (bornes incluses).
  fpError renvoie True si Ok, sinon False }
begin
  try
    ipResultat:=strToInt(spResultat);
  except
    on E: EConvertError do fpError:=True;
  end;
  if (fpError = False) then begin
    if (ipResultat < ipMin) then begin
      ShowMessage(spResultat+' est trop petit');
      fpError:=True;
    end;
    if (ipResultat > ipMax) then begin
      ShowMessage(spResultat+' est trop grand');
      fpError:=True;
    end;
  end;
end;

procedure charge_solution(siNbSol: string);
var
  finput: textFile;
  i,j: integer;
  sEnreg: string;
begin
  { Charge un fichier solution dans le TstringList slgSolution }
  AssignFile(finput,'Solution'+copy('00000'+siNbSol,length(siNbSol),6)+'.txt');
  {$I-}
  reset(finput);
  {$I+}
  readln(finput,sEnreg);
  readln(finput,sEnreg);
  { Lit les cases }
  for i := 0 to 8 do begin
    readln(finput,sEnreg);
    for j := 0 to 8 do begin
      slgSolution[indice(j,i)]:=trim(copy(sEnreg,1+(9*j),9));
    end;
  end;
  closeFile(finput);
end;

procedure TForm1.Affichesolution1Click(Sender: TObject);
var
  iNbSol,i: integer;
  sNbSol,sOldNbSol: string;
  HeureDate: TDateTime;
  fBoucle,fErr: boolean;
  rDuree: double;
begin
  { Calcule et affiche la (ou les) solutions }
  HeureDate:=time();
  { Calcule la (ou les) solutions }
  iNbSol:=calcule_Solution(Sender);
  rDuree:=round(86400000*(time()-HeureDate))/1000;
  MessageDlg('Dure:'+FloatToStr(rDuree)+' secondes',mtInformation,[mbOk],0);
  { affiche une solution }
  if iNbSol = 0 then begin
    MessageDlg('Il n''y a pas de solution',mtWarning,[mbOk],0);
  end
  else begin
    fgAfficheSolution:=True;
    if (iNbSol = 1) then begin
      MessageDlg('Il y a 1 solution',mtInformation,[mbOk],0);
      charge_solution('1');
      FormPaint(Sender);
    end
    else begin
      fBoucle:=True;
      sNbSol:='0';
      repeat
        sOldNbSol:=sNbSol;
        if not InputQuery('Il y a '+intToStr(iNbSol)+' solutions',
                          'Saisir le numro de la solution  afficher',sNbSol) then begin
          fBoucle:=False;
        end
        else begin
          verifie_nombre(sNbSol,1,iNbSol,i,fErr);
          if (fErr = True) then sNbSol:=sOldNbSol
          else begin
            charge_solution(sNbSol);
            FormPaint(Sender);
          end;
        end;
      until (fBoucle = False);
    end;
    fgAfficheSolution:=False;
    if (sNbSol <> '0') then
      if (MessageDlg('Retour au jeu',mtInformation,[mbYes,mbNo],0) = mrNo) then
        for i := 0 to slgSolution.Count - 1 do
          slgCase[i]:=SlgSolution[i];
    FormPaint(Sender);
  end;
end;

procedure TForm1.affiche_case(Sender: TObject;ipCase,ipType: integer;spString: string);
{ Affiche une case en grise si c'est la case courante (igCaseCourante) et en blanc sinon.
  Celon le type :
  - 0 : case vide
  - 1 : case donne initialement => chiffre en noir
  - 2 : case trouve (ou suppose trouve) => chiffre en bleu
  - 3 : plusieurs possibilits => petits chiffres en vert spars par des virgules }
var
  iLigne,iColonne,iTop,iLeft,iBottom,iRight: integer;
  rCase: Trect;
  sAffiche: string;
begin
  if fgGrilleChargee = True then begin
    iLigne:=trunc(ipCase/9);
    iColonne:=ipCase mod 9;
    iLeft:=(60*iColonne)+11;
    if (iColonne mod 3 = 0) then iLeft:=iLeft+1;
    iTop:=(60*iLigne)+31;
    if (iLigne mod 3 = 0) then iTop:=iTop+1;
    iRight:=(60*(iColonne+1))+10;
    if (iColonne mod 3 = 2) then iRight:=iRight-1;
    iBottom:=(60*(iLigne+1))+30;
    if (iLigne mod 3 = 2) then iBottom:=iBottom-1;
    rCase:=Rect(iLeft,iTop,iRight,iBottom);
    Canvas.Brush.Style:=bsSolid;
    if ipCase = igCaseCourante then
      Canvas.Brush.Color:=clLtGray
    else
      Canvas.Brush.Color:=clWhite;
    Canvas.FillRect(rCase);
    Canvas.Font.Name:='Arial Bold';
    sAffiche:=trim(spString);
    if length(sAffiche) > 5 then sAffiche:=copy(sAffiche,1,5)+'..';
    if ipType = 1 then Canvas.Font.Color:=clBlack;
    if ipType = 2 then Canvas.Font.Color:=clBlue;
    if (ipType = 1) or (ipType = 2) then Canvas.Font.Size:=32;
    if ipType = 3 then begin
      Canvas.Font.Color:=clGreen;
      Canvas.Font.Size:=8;
    end;
    if (ipType >= 1) and (ipType <= 3) then
      Canvas.TextOut((60*iColonne)+30,(60*iLigne)+32,sAffiche);
  end;
end;

procedure TForm1.FormClick(Sender: TObject);
var
  iLigne,iColonne: integer;
begin
  if (igx > 12) and (igx < 552) and
     (igy > 32) and (igy < 572) then begin
    iLigne:=trunc((igy-32)/60);
    iColonne:=trunc((igx-12)/60);
    if (igCaseCourante <> indice(iColonne,iLigne)) then begin
      if (fgEditJeu = True) or
        ((fgEditJeu = False) and (copy(slgCase[indice(iColonne,iLigne)],1,1) <> '1')) then begin
        deplace_case_courante(Sender,indice(iColonne,iLigne),True);
      end;
    end;
  end;
end;

procedure TForm1.deplace_case_courante(Sender: TObject;ipCase: integer; fpMemorise: boolean);
{ procedure qui dplace la case courante (igCaseCourante) pour la case ipCase
  Cette procdure mmorise la case qui est quitte dans slgCaseJouee
  (indice+'/'+contenu)
  L'ancienne case est affiche normalement.
  la nouvelle est grise, sa valeur est mise dans sgEdit,
  son indice est mis dans sgCaseCourante, la case est mise en sgOldCase }
var
  iOldCaseCourante,iType,iCase: integer;
  sCase,sOldCase: string;
begin
  if (ipCase > -1) and (ipCase < slgCase.Count) then begin
    if (slgCase[igCaseCourante] <> sgOldCase) and (fgEditJeu = False) and
       (fpMemorise = True) then begin
      if (copy(slgCase[igCaseCourante],2,length(slgCase[igCaseCourante])-1) =
          copy(sgOldCase,2,length(sgOldCase)-1)) then begin
        decode_casejouee((slgCaseJouee.count-1),iCase,sOldCase);
        if (igCaseCourante = iCase) then
          slgCaseJouee[slgCaseJouee.count-1]:=intToStr(igCaseCourante)+'/'+sOldCase
        else begin
          slgCaseJouee.Add(intToStr(igCaseCourante)+'/'+sgOldCase);
        end;
      end
      else begin
        slgCaseJouee.Add(intToStr(igCaseCourante)+'/'+sgOldCase);
      end;
      { panneau 2 : nombre de coups jous }
      StatusBar1.Panels[2].Text:=copy(intToStr(slgCaseJouee.count)+'          ',1,10);
    end;
    iOldCaseCourante:=igCaseCourante;
    igCaseCourante:=ipCase;
    decode_case(slgCase,iOldCaseCourante,iType,sCase);
    affiche_Case(Sender,iOldCaseCourante,iType,sCase);
    decode_case(slgCase,igCaseCourante,iType,sCase);
    affiche_Case(Sender,igCaseCourante,iType,sCase);
    sgEdit:=sCase;
    sgOldCase:=slgCase[igCaseCourante];
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  F: TSearchRec;
begin
  slgCase:=TstringList.Create;
  slgCaseJouee:=TstringList.Create;
  slgSolution:=TstringList.Create;
  fgGrilleChargee:=False;
  fgSolutionTrouvee:=False;
  fgEditJeu:=False;
  igHypothese:=0;
  igCaseCourante:=-1;
  { efface tous les fichiers solutions prcedents }
  if (findFirst('.\\Solution*.txt',0,F) = 0) then
  repeat
    deleteFile(F.Name);
  until (FindNext(F) <> 0);
end;

procedure TForm1.FormDblClick(Sender: TObject);
var
  iCaseErronee,iCaseUniSol,iCaseMultiSol,iType: integer;
  sSol: string;
begin
  if (fgEditJeu = False) then begin
    decode_case(slGcase,igCaseCourante,iType,sSol);
    if (iType = 3) and (pos(',',sgEdit) = 0) and (sgEdit <> '') then begin
      { case avec une solution saisie unique }
      slgCase[igCaseCourante]:='2'+sgEdit;
      affiche_case(Sender,igCaseCourante,2,sgEdit);
      verifie_grille(iCaseErronee,iCaseUniSol,iCaseMultiSol);
      if (iCaseUniSol = -1) and (iCaseMultiSol = -1) then begin
        { le jeu est fini }
        if (iCaseErronee > -1) then
          MessageDlg('Il y a au moins une erreur',mtError,[mbOk],0)
        else begin
          { La grille est finie sans erreur }
          deplace_case_courante(Sender,igCaseCourante,True);
          MessageDlg('Solution trouve, Bravo !!!!!',mtInformation,[mbOk],0);
        end;
      end
      else begin
        StatusBar1.Panels[2].Text:=copy(intToStr(slgCaseJouee.count)+'          ',1,10);
      end;
    end;
  end;
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
var
  i,iType: integer;
  sOldEdit,sW: string;
begin
  { saisie avec le clavier }
  decode_case(slgCase,igCaseCourante,iType,sgEdit);
  sOldEdit:=sgEdit;
  if ((key >= '0') and (Key <= '9')) or
  ((key = ',') and (fgEditJeu = False)) then sgEdit:=sgEdit+Key;
  if (key = chr(vk_back)) and (length(sgEdit) > 0) then sgEdit:=copy(sgEdit,1,length(sgEdit)-1);
  sW:=sgEdit;
  i:=pos(',',sW);
  repeat
    if (i > 0) then begin
      sW:=copy(sW,i+1,length(sW));
      i:=pos(',',sW);
    end;
  until (i = 0);
  if (sW <> '') then begin
    i:=strToInt(sW);
    if ((i < 1) or (i > 9)) then sgEdit:=sOldEdit;
  end;
  if (fgEditJeu = True) then begin
    { en mode modification de grille, on ne saisie que des valeurs initiales }
    if length(sgEdit) > 0 then iType:=1
    else iType:=0;
  end
  else
    { en mode jeu, on ne saisie que des solutions multiple }
    if length(sgEdit) > 0 then iType:=3
    else iType:=0;
  slgCase[igCaseCourante]:=intToStr(iType)+sgEdit;
  affiche_case(Sender,igCaseCourante,iType,sgEdit);
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
begin
  igX:=X;
  igY:=Y;
end;

procedure TForm1.Importer1Click(Sender: TObject);
var
  finput: textFile;
  sEnreg,sCase: string;
  i,iNbCase,iType: integer;
begin
  { Choix de la grille }
  OpenDialog1.Filter:='Grilles Sudoku|*.txt|Tous fichiers|*.*';
  if OpenDialog1.Execute then begin
    sgFichierGrille:=OpenDialog1.FileName;
    { Chargement de la grille }
    AssignFile(finput,sgFichierGrille);
    {$I-}
    reset(finput);
    {I+}
    if IOResult = 0 then begin
      { Taille de la grille toujours  9 x 9 }
      slgCase.Clear;
      slgCaseJouee.Clear;
      { Dessine la grille }
      { Charge les cases }
      iNbCase:=0;
      igHypothese:=0;
      fgGrilleChargee:=True;
      while (not eof(finput)) do begin
        readln(finput,sEnreg);
        if (length(sEnreg) <> 9) then
          { erreur de format : pas 9 caractres }
          fgGrilleChargee:=False
        else begin
          for i := 1 to 9 do begin
            inc(iNbCase);
            sCase:=copy(sEnreg,i,1);
            if (sCase >= '1') and (sCase <= '9') then slgCase.Add('1'+sCase)
            else if (sCase = '0') then slgCase.Add('0')
            else
              { erreur de format : caractre non numrique }
              fgGrilleChargee:=False;
          end;
        end;
      end;
      system.close(finput);
      if (iNbCase <> 81) or (fgGrilleChargee = False) then begin
        { erreur de format : pas 9 lignes }
        fgGrilleChargee:=False;
        MessageDlg('Erreur de format (pas 9 lignes de 9 caractres numriques)',mtError,[mbOk],0)
      end
      else begin
        fgSolutionTrouvee:=False;
        fgAfficheSolution:=False;
        fgGrilleChargee:=True;
        { recherche la case courante }
        igCaseCourante:=-1;
        for i := 0 to slgCase.Count - 1 do
          if (igCaseCourante = -1) and (copy(slgCase[i],1,1) <> '1') then
            igCaseCourante:=i;
        sgOldCase:=slgCase[igCaseCourante];
        decode_case(slgCase,igCaseCourante,iType,sCase);
        sgEdit:=sCase;
        i:=pos('.',sgFichierGrille);
        if (i > 0) and (copy(sgFichierGrille,i+1,length(sgFichierGrille)-i) <> 'sdk') then
          sgFichierGrille:=copy(sgFichierGrille,1,i)+'sdk'
        else sgFichierGrille:=copy(sgFichierGrille,1,i-1)+'2.sdk';
        FormPaint(Sender);
      end;
    end;
  end;
end;

procedure TForm1.Jouer1Click(Sender: TObject);
var
  i: integer;
begin
  if (fgEditJeu = True) then begin
    if copy(slgCase[igCaseCourante],1,1) = '1' then begin
      igCaseCourante:=-1;
      for i := 0 to slgCase.Count - 1 do
        if (igCaseCourante = -1) and (copy(slgCase[i],1,1) <> '1') then
          igCaseCourante:=i;
    end;
    if (igCaseCourante > -1) then begin
      fgEditJeu:=False;
      FormPaint(Sender);
    end;
  end;
end;

procedure TForm1.Modifiergrille1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to slgCase.Count - 1 do
    if (length(slgCase[i]) > 0) then
      if (copy(slgCase[i],1,1) <> '1') then slgCase[i]:='0';
  fgEditJeu:=True;
  fgSolutionTrouvee:=False;
  slgCaseJouee.Clear;
  { panneau 0 : nom du fichier grille }
  StatusBar1.Panels[0].Text:=copy(sgFichierGrille+'                              ',1,30);
  { panneau 1 : mode conception ou jeu }
  StatusBar1.Panels[1].Text:='Conception ';
  { panneau 2 : nombre de coups jous }
  StatusBar1.Panels[2].Text:=copy(intToStr(slgCaseJouee.count)+'          ',1,10);
  { panneau 3 : solutions possibles }
  StatusBar1.Panels[3].Text:='';
  { Dessine la grille }
  FormPaint(Sender);
end;

procedure TForm1.Nouvellegrille1Click(Sender: TObject);
var
  i,j: integer;
begin
  { nombre de cases limite de 2  4 (initialement prvu de 2  5) }
  sgFichierGrille:='';
  slgCase.Clear;
  { Charge les cases }
  for i := 0 to 9 do
    for j := 0 to 9 do
      slgCase.Add('0');
  fgEditJeu:=True;
  fgSolutionTrouvee:=False;
  fgGrilleChargee:=True;
  igCaseCourante:=0;
  fgSolutionTrouvee:=False;
  fgAfficheSolution:=False;
  slgCaseJouee.Clear;
  { panneau 0 : nom du fichier grille }
  StatusBar1.Panels[0].Text:=copy(sgFichierGrille+'                              ',1,30);
  { panneau 1 : mode conception ou jeu }
  StatusBar1.Panels[1].Text:='Conception ';
  { panneau 2 : nombre de coups jous }
  StatusBar1.Panels[2].Text:=copy(intToStr(slgCaseJouee.count)+'          ',1,10);
  { panneau 3 : solutions possibles }
  StatusBar1.Panels[3].Text:='';
  { Dessine la grille }
  FormPaint(Sender);
end;

procedure TForm1.Quitter1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Rinitialiser1Click(Sender: TObject);
var
  i: integer;
begin
  igCaseCourante:=-1;
  for i := 0 to slgCase.Count - 1 do
    if (copy(slgCase[i],1,1) <> '1') then begin
      slgCase[i]:='0';
      if (igCaseCourante = -1) then igCaseCourante:=i;
    end;
  slgCaseJouee.Clear;
  fgEditJeu:=False;
  fgAfficheSolution:=False;
  FormPaint(Sender);
  igHypothese:=0;
end;

end.
